# -*- coding: utf-8 -*-
"""svm_misclassfied_data.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1MJS8rD9_e3IV7ahaVCHJbKsx8LYCRjQG
"""

import pandas as pd
from sklearn.feature_extraction.text import TfidfVectorizer 
import matplotlib.pyplot as plt
import numpy as np
from sklearn.svm import SVC
import logging
logging.basicConfig(filename="SVM.log", 
                    format='%(asctime)s %(message)s', 
                    filemode='w') 
logger=logging.getLogger() 
  
logger.setLevel(logging.DEBUG)
class svm_classifier:
  def __init__(self):
    self.train()

  def train(self):
    try:
      support=open("/content/support (3).txt","r").readlines()
      bully=open("/content/bully (3).txt","r").readlines()
    except:
      logger.warning("error occured during reading the files")
    label=[]
    comm=[]
    for i in bully:
      label.append('bullying')
      comm.append(i[:-1].lower())

    for i in support:
      label.append('support')
      comm.append(i[:-1].lower())
    df = pd.DataFrame({'sentence':comm, 'label':label})    
    logger.info("Loading the features")  

    try:
      f=open("/content/features (2).txt","r").readlines()
    except:
      logger.warning("error occured during reading features file")

    features=[]
    for i in f:
      features.append(i[:-1].lower()) 
    tfidfconverter = TfidfVectorizer(max_features=63,vocabulary=features,ngram_range=(1, 3))  
    X = tfidfconverter.fit_transform(comm).toarray()
    logger.info("vectorization using tf-idf")

    idf=tfidfconverter.idf_
    rr=dict(zip(tfidfconverter.get_feature_names(), idf))
    pd.DataFrame(rr.items())

    from sklearn.model_selection import train_test_split  
    X_train, X_test, y_train, y_test = train_test_split(X, label, test_size=0.2, random_state=0,stratify=label)
    logger.info("Spliting data into training and test")
    from sklearn.model_selection import GridSearchCV
    #Hyperparameter tuning
    param_grid = {'C': [0.1, 0.2, 0.7, 1, 2, 5, 10,20], 
              'gamma': [1, 0.75, 0.5, 0.25, 0.1, 0.01, 0.001],
              'degree':[1, 2, 3, 4, 5, 6],
              'kernel': ['rbf', 'poly', 'linear']} 

    grid = GridSearchCV(SVC(), param_grid)
    grid.fit(X_train, y_train)

    best_params = grid.best_params_
    print(f"Best params: {best_params}")
    svm_clf = SVC(**best_params)

    svm_clf.fit(X_train, y_train)

    predictions = svm_clf.predict(X_test)
    from sklearn.metrics import classification_report, confusion_matrix, accuracy_score

    print(confusion_matrix(y_test,predictions))  
    print(classification_report(y_test,predictions))  
    print(accuracy_score(y_test, predictions))
    logger.info("showing the accuracy")
    k=len(predictions)
    z=[]
    bull=0
    supp=0
    for i in range(0,k):   #count of misclassified data in each class 
      if(predictions[i]!=y_test[i]):
        z.append(i)
        if(predictions[i]=='bullying'):
          bull=bull+1
        else:
          supp=supp+1
    print(z)
    print(supp)
    print(bull)

    f=open("misclassified.txt",'w')
    o=tfidfconverter.fit_transform(comm).toarray()
    predict=svm_clf.predict(o)
    print(input,predict)
    s=[]
    for comma, predicts, labels in zip(comm,predict,label): #obtaining misclassified data
      if(predicts!=labels):
        s.append(comma)
    print(s) 
    for i in s:
      f.write(i)
      f.write("\n")

svm_classifier()